var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01212;
(function (F01212) {
    var StrKeysP1TotalF012Xx = F012XX.P1TotalStrKeys;
    var FDocument = (function (_super) {
        __extends(FDocument, _super);
        function FDocument(id, version, oldVersion) {
            var _this = _super.call(this, id, version, oldVersion) || this;
            _this._p3Sp1Table = null;
            _this._p3Sp2Table = null;
            _this._p3Sp6Table = null;
            _this._p4Sp3Table = null;
            _this._p3Sp1Sheet = null;
            _this._tableRules = new F01212.TableRules(_this);
            _this._interfaceRules = new F01212.InterfaceRules(_this);
            _this._updateRules = new F01212.UpdateRules(_this);
            _this._exportRules = new F01212.ExportRules(_this);
            return _this;
        }
        Object.defineProperty(FDocument.prototype, "P3Sp1Table", {
            get: function () {
                if (this._p3Sp1Table == null) {
                    this._p3Sp1Table = new F01211.PXSp1ObasTable("F01_212_3_1_Values", this, StrKeysP1TotalF012Xx.P3, FDocument._keyFieldIs);
                }
                return this._p3Sp1Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P3Sp2Table", {
            get: function () {
                if (this._p3Sp2Table == null) {
                    this._p3Sp2Table = new F01211.PXSp2ObasTable("F01_211_3_2_Values", this, this.P3Sp1Table, this.P3Sp6Table, FDocument._keyFieldIs, "F01_211_3_2_Rows");
                }
                return this._p3Sp2Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P3Sp6Table", {
            get: function () {
                if (this._p3Sp6Table == null) {
                    this._p3Sp6Table = new F01211.PXSp6ObasTable("F01_211_3_6_Values", this, this.P3Sp1Table);
                }
                return this._p3Sp6Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P4Sp3Table", {
            get: function () {
                if (this._p4Sp3Table == null) {
                    this._p4Sp3Table = new F01212.P4Sp3ObasTable("F01_211_4_2", this);
                }
                return this._p4Sp3Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P3Sp1Sheet", {
            get: function () {
                if (this._p3Sp1Sheet == null) {
                    this._p3Sp1Sheet = new F01211.PXSp1Sheet("SHT_F01_212_3_1", this, this.P3Sp1Table.IsEditCorrection);
                }
                return this._p3Sp1Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableRules", {
            get: function () {
                return this._tableRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "InterfaceRules", {
            get: function () {
                return this._interfaceRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "UpdateRules", {
            get: function () {
                return this._updateRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "ExportRules", {
            get: function () {
                return this._exportRules;
            },
            enumerable: true,
            configurable: true
        });
        return FDocument;
    }(F01211.FDocument));
    F01212.FDocument = FDocument;
})(F01212 || (F01212 = {}));
